#include "graph.cpp"
#include <stdio.h>

#define maxN 500
#define maxStones 1000

int N, M, currentVertex, markedVertex, whereToGo, answer, neighborsCount;
int edges[maxN + 1][maxN], edgesCount[maxN + 1], stones[maxN + 1], neighbors[maxN];

int main()
{
    freopen("graph.dat", "r", stdin);
    freopen("graph.sol", "w", stdout);

    scanf("%d %d %d %d", &N, &M, &currentVertex, &markedVertex);
    for (int i = 1; i <= N; i++)
    {
        edgesCount[i] = 0;
        stones[i] = 0;
    }
    if (markedVertex > 0)
        stones[markedVertex] = 1;
    for (int i = 0; i < M; i++)
    {
        int a, b;
        scanf("%d %d", &a, &b);
        edges[a][edgesCount[a]] = b;
        edgesCount[a]++;
        edges[b][edgesCount[b]] = a;
        edgesCount[b]++;
    }
    while (true)
    {
        for (int i = 0; i < edgesCount[currentVertex]; i++)
            neighbors[i] = stones[edges[currentVertex][i]];
        whereToGo = answer = -1;
        graph(markedVertex == 0 ? 1 : 2, edgesCount[currentVertex], neighbors, stones[currentVertex], whereToGo, answer);
        if (stones[currentVertex] < 0 || stones[currentVertex] > maxStones)
        {
            printf("ʳ       䒺    %d.\n", maxStones);
            break;
        }
        if (whereToGo != -1 && answer != -1)
        {
            printf("          .\n");
            break;
        }
        if (whereToGo == -1 && answer == -1)
        {
            printf("         ,  .\n");
            break;
        }
        if (answer != -1)
        {
            printf("%d\n", answer);
            break;
        }

        bool found = false;
        for (int i = 0; i < edgesCount[currentVertex]; i++)
            if (stones[edges[currentVertex][i]] == whereToGo)
            {
                currentVertex = edges[currentVertex][i];
                found = true;
                break;
            }
        if (! found)
        {
            printf("     ,   .\n");
            break;
        }
    }

    return 0;
}
