{$I graph.pas}

const maxN = 500;
      maxStones = 1000;

var i, N, M, currentVertex, markedVertex, whereToGo, answer, neighborsCount, a, b, subproblem: longint;
    edges: array[1..maxN] of array[1..maxN] of longint;
    edgesCount, stones: array[1..maxN] of longint;
    neighbors: array of longint;
    found: boolean;

begin
    assign(input, 'graph.dat');
    reset(input);
    assign(output, 'graph.sol');
    rewrite(output);

    read(N, M, currentVertex, markedVertex);
    for i := 1 to N do begin
        edgesCount[i] := 0;
        stones[i] := 0;
    end;
    if markedVertex > 0 then
        stones[markedVertex] := 1;
    for i := 1 to M do begin
        read(a, b);
        inc(edgesCount[a]);
        edges[a][edgesCount[a]] := b;
        inc(edgesCount[b]);
        edges[b][edgesCount[b]] := a;
    end;
    while true do begin
        setlength(neighbors, edgesCount[currentVertex]);
        for i := 1 to edgesCount[currentVertex] do
            neighbors[i - 1] := stones[edges[currentVertex][i]];
        whereToGo := -1;
        answer := -1;
        if markedVertex = 0 then
            subproblem := 1
        else
            subproblem := 2;
        graph(subproblem, edgesCount[currentVertex], neighbors, stones[currentVertex], whereToGo, answer);
        if (stones[currentVertex] < 0) or (stones[currentVertex] > maxStones) then begin
            writeln('Kilkist kamintsiv v odniy z vershyn vyiavylasia vidyemnoyu abo bilshoyu za ', maxStones, '.');
            break;
        end;
        if (whereToGo <> -1) and (answer <> -1) then begin
            writeln('Protsedura povernula vodnochas instruktsiyu ity v odnu z vershyn ta rezultat.');
            break;
        end;
        if (whereToGo = -1) and (answer = -1) then begin
            writeln('Protsedura ne povernula ni instruktsiyi ity v odnu z vershyn, ni rezultatu.');
            break;
        end;
        if answer <> -1 then begin
            writeln(answer);
            break;
        end;

        found := false;
        for i := 1 to edgesCount[currentVertex] do
            if stones[edges[currentVertex][i]] = whereToGo then begin
                currentVertex := edges[currentVertex][i];
                found := true;
                break;
            end;
        if not found then begin
            writeln('Protsedura povernula nepravylnu instruktsiyu shchodo vershyny, kudy slid pereyty.');
            break;
        end;
    end;

    close(input);
    close(output);
end.
